// global vars
var timeout = null
	padding = 11,
	maxWidth = 260,
	minWidth = 140;

// run when the DOM has changed
document.addEventListener("DOMSubtreeModified", function() {
	// set a timeout has been set
    if(timeout) {
    	// clear the timer
        clearTimeout(timeout);
    }
    // set a timeout to resize 100 milliseconds after dom changes
    timeout = setTimeout(resizeLists, 100);
}, false);

// getElementsByClassName shortcut
function $c(className) {
	return document.getElementsByClassName(className);
}

// getElementById shortcut
function $i(id) {
	return document.getElementById(id);
}

// resize each the lists
function resizeLists() {
	// get all the lists
	var lists = $c('list-wrapper');
	// if there is at least one list
	if(lists[0] !== undefined) {
		// lots of variables to set up everything
			// the width of the lists
		var listWidth = lists[0].offsetWidth,
			// get the list area
			listArea = $i('board'),
			// get the width of the list area
			listAreaWidth = listArea.offsetWidth,
			// get the wrapper width for the list area
			listAreaWrapperWidth = $c('board-wrapper')[0].offsetWidth,
			/* work out the ideal width (wrapper width divided by the number of lists (minus the Add list option), minus the padding of each list) */
			idealListWidth = Math.floor((listAreaWrapperWidth / (lists.length - 1)) - padding),
			// set the new list area width
			newListAreaWidth = 0;
		// if there list area wrapper is smaller than the list area width
		if(listAreaWrapperWidth < (lists.length * maxWidth)) {
			for(var i = 0, listCount = lists.length; i < listCount; i++) {
				// if the ideal list width is more than minimum width AND less than the max width
				if(idealListWidth > minWidth && idealListWidth < maxWidth) {
					// set the list width to the ideal width
					lists[i].style.width = idealListWidth + 'px';
					// increment the new list width
					newListAreaWidth += (idealListWidth + padding);
				// if the ideal list width is less than the min width
				} else if(idealListWidth <= minWidth) {
					// set the ideal width to be the min width
					idealListWidth = minWidth;
					// set the list width to be the minimum allowed
					lists[i].style.width = idealListWidth + 'px';
					// increment the new list width
					newListAreaWidth += (minWidth + padding);
				}
			}
			// if the ideal list width is less than the max width
			if(idealListWidth < maxWidth) {
				// change the list area width
				listArea.style.width = newListAreaWidth + 'px!important';
			}
		}
	}
}